﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace HttpWebRequestTestServer
{
    public partial class Form1 : Form
    {
        static int _count = 0;

        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            using (Socket serverSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp))
            {
                serverSocket.Bind(new IPEndPoint(IPAddress.Any, 9982));
                serverSocket.Listen(5);

                while (true)
                {
                    Socket socket = serverSocket.Accept();
                    ThreadPool.QueueUserWorkItem(processChildSocket, socket);
                }
            }
        }

        private void processChildSocket(object state)
        {
            int idx = Interlocked.Increment(ref _count);

            using (Socket child = state as Socket)
            {
                byte[] buf = new byte[8192];
                int len = child.Receive(buf);

                string txt = Encoding.UTF8.GetString(buf, 0, len);
                Console.WriteLine("[" + idx + "]" + DateTime.Now + Environment.NewLine + txt);

                byte[] responseBuf = GetResponseData(txt);

                child.Send(responseBuf);
                child.Close();
            }
        }

        private byte[] GetResponseData(string recvData)
        {
            string parsingData = "{\r\n    \"code\": 0,\r\n    \"create_on\": \"2022-06-30T18:21:25.073Z\",\r\n    \"msg\": \"ok\"\r\n}";
            string header = "HTTP/1.1 200 OK\r\nContent-Type: application/json; charset=UTF-8\r\n\r\n";
            string body = string.Format("{0}", parsingData);
            byte[] respBuf = Encoding.UTF8.GetBytes(header + body);
            return respBuf;
        }
    }
}
